=== debian/changelog ===
ros-foxy-openzen-driver (1.2.0-2focal) focal; urgency=high

  * init version

 -- Thomas Hauth <thomas@lp-research.com>  Mon, 19 Apr 2021 15:00:00 -0000
