=== debian/control ===
Source: ros-foxy-openzen-driver
Section: misc
Priority: optional
Maintainer: Thomas Hauth <thomas@lp-research.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-launch, ros-foxy-launch-testing, ros-foxy-rclcpp, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-std-srvs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-openzen-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rclcpp, ros-foxy-rqt-plot, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-std-srvs, ros-foxy-ros-workspace
Description: ROS 2 Driver for LP-Research inertial measurement units and satellite navigation senors
